theory Partiality
imports MList
begin

section{* Partial Functions *}

fun hd1 :: "'a mlist \<Rightarrow> 'a"
where "hd1 (Cons x xs) = x"

fun tl1 :: "'a mlist\<Rightarrow> 'a mlist"
where "tl1 (Cons x xs) = xs"

fun not_empty :: "'a mlist\<Rightarrow> bool"
where "not_empty Mt = False"
    | "not_empty (Cons x xs) = True"

lemma "Cons (hd1 xs) (tl1 xs) = xs"
 apply (induction xs)
 apply (simp+) --{* Does not work *}
 oops

lemma "not_empty xs \<longrightarrow> Cons (hd1 xs) (tl1 xs) = xs"
 apply (induction xs)
 apply (simp)+
 done

fun hd2 :: "'a mlist\<Rightarrow> 'a option"
where "hd2 (Cons x xs) = Some x"
    | "hd2 Mt          = None"

fun tl2 :: "'a mlist\<Rightarrow> 'a mlist option"
where "tl2 (Cons x xs) = Some xs"
    | "tl2 Mt          = None"

lemma "not_empty xs \<longrightarrow> Cons (the (hd2 xs)) (the (tl2 xs)) = xs"
  apply (induction xs, simp+)
  done

end


ML_val {* @{thm undefined_def} *}

