theory ListComp
imports Main
begin

definition pairs :: "'a list\<Rightarrow> 'b list\<Rightarrow> ('a * 'b) list"
where "pairs xs ys \<equiv> [(x, y) . x <- xs, y<- ys]"

lemma pairex: "pairs [1,2] [3,4] = [(1,3), (1, 4), (2, 3), (2, 4)]"
  by (simp add: pairs_def)

lemma pairs_len: "length (pairs xs ys) = length xs* length ys" 
  apply (unfold pairs_def)
  apply (induction xs) 
  apply (simp)+
  done

end
